#!/usr/bin/perl
#============================================================================
# PMA Bulletin Board
#
# Coded by:    Eric J. Koskinen
# Date:        8 April 1999
#============================================================================

use CGI qw (:standard);
use CGI::Carp qw(fatalsToBrowser);

$bulletin = "data/bulletinboard.txt";
$oldfile  = "data/oldmessages.txt";
$sigsfile = "data/bulletinboardsigs.txt";
$fontcolor = "#000000";
$backcolor = "#FFFFFF";

$q = new CGI;
print $q->header;
$signature    = $q->param(signature);
$remoteguy    = $q->remote_host();
$moreinfo     = $q->user_name();
$moreinfo2    = $q->remote_user();
$action       = $q->param(action);
$changeme     = $q->param(changeme);
$linetoadd    = $q->param(linetoadd);
$linetomodify = $q->param(linetomodify);
$key          = $q->param(key);
#============================================================================
&analyzeuser;
if     ($key eq "add")        { $key = "done";      &doit_add;      exit; }
elsif  ($key eq "remove")     { $key = "done";      &doit_remove;   exit; }
elsif  ($key eq "modify")     { $key = "modify2";   &modify_step;   exit; }
elsif  ($key eq "modify2")    { $key = "done";      &doit_modify;   exit; }
elsif  ($action =~ /Add/i)    { $key = "add";       &add_item;      exit; }
elsif  ($action =~ /Modify/i) { $key = "modify";    &choose_item;   exit; }
elsif  ($action =~ /Delete/i) { $key = "remove";    &choose_item;   exit; }
else                          { $key = "";          &print_default; exit; }
#============================================================================
sub doit_add {
  &load_items;
  if($signature ne "") { @sigs = ("$signature\n", @sigs) }
  else { @sigs  = ("$remoteguy\n", @sigs) }
#  $linetoadd =~ s/[<>]//gi; #censor web links#
  @items = ("$linetoadd\n", @items);
  $savethisone=pop(@items);
  &save_items;
  $key = "done";
  print $q->start_html(-TITLE=>'PMA Bulletin Board - Added Item',-BGCOLOR=>"$backcolor");
print<<HTML;
   <CENTER><BR><FONT SIZE=+1 COLOR="$fontcolor">Item Added to Bulletin Board</FONT><BR>
   <FORM ACTION="bulletin.cgi" METHOD=POST>
   <HR WIDTH=75%>
   <INPUT TYPE=HIDDEN NAME=key value="$key"><BR>
   <INPUT TYPE=SUBMIT NAME=action VALUE="Return to Main"></CENTER>
   </FORM></CENTER></BODY></HTML>
HTML
  close(BULLETIN);
}
#====================================================================================
sub add_item
{
  print $q->start_html(-TITLE=>'PMA Bulletin Board - Add an Item',-BGCOLOR=>"$backcolor"),
        $q->start_form;
print<<HTML;
   <CENTER><FONT SIZE=+1 COLOR="$fontcolor">Enter Item to Add:</FONT><BR><BR>
   <INPUT TYPE=HIDDEN NAME=key value="$key">
   <INPUT TYPE=TEXT NAME=linetoadd SIZE="60"><CENTER><BR>
   <font size=+1 color=$fontcolor>Signature:</font>
   <INPUT TYPE=TEXT NAME=signature SIZE=17><br><br>
   <INPUT TYPE=SUBMIT NAME=action value="Submit"></FORM>
   </CENTER></BODY></HTML>
HTML
}
#====================================================================================
sub choose_item {
  &load_items;
  print $q->start_html(-TITLE=>'PMA Bulletin Board - Choose Item',-BGCOLOR=>"$backcolor"),
        $q->start_form;
  print "<CENTER><FONT SIZE=+1 COLOR=\"$fontcolor\">Choose Item";
  if($key eq "modify") { print " To Modify"; }
  else { print " To Remove"; }
  print "</FONT><BR><BR><FORM ACTION=\"bulletin.cgi\" METHOD=POST>";
  print "<INPUT TYPE=HIDDEN NAME=key value=\"$key\">";
  print "<TABLE BORDER=0 CELLSPACING=0>";
  $modnum = 0;
  foreach $item (@items){
    print "<TR><TD>";
    if ($modnum == 0) { print "<INPUT TYPE=RADIO NAME=changeme VALUE=\"$modnum\" checked></TD>"; }
    else              { print "<INPUT TYPE=RADIO NAME=changeme VALUE=\"$modnum\" unchecked></TD>"; }
    $modnum = $modnum + 1;
    print "</TD><TD><FONT COLOR=$fontcolor>$item</FONT></TD></TR>";
  } # End of foreach.
print "<TR><TD COLSPAN=2><CENTER>";
if ($key eq "modify")      { print "<INPUT TYPE=SUBMIT NAME=action VALUE=\"Modify This Record\">"; }
else                       { print "<INPUT TYPE=SUBMIT NAME=action VALUE=\"Remove This Record\">"; }
print "</CENTER></TD></TR></TABLE></CENTER></FORM></BODY></HTML>";
}
#===================================================================================================
sub doit_remove {
  &load_items;
  print $q->start_html(-TITLE=>'PMA Bulletin Board - Remove Items',-BGCOLOR=>"$backcolor"),
        $q->start_form;
  $myi = 0;
  for ($myi = ($changeme); $myi < ((@items)-1); ++$myi) { $items[$myi] = $items[($myi + 1)]; }
  for ($myi = ($changeme); $myi < ((@sigs)-1);  ++$myi) { $sigs[$myi]  = $sigs[($myi + 1)];  }
  $garb = pop(@items);
  $garb = pop(@sigs);
  &save_items;
print<<HTML;
   <CENTER><FONT SIZE=+1 COLOR="$fontcolor">Item Removed</FONT><BR>
   <FORM ACTION="bulletin.cgi" METHOD=POST>
   <HR WIDTH=75%><BR>
   <INPUT TYPE=HIDDEN NAME=key value="$key">
   <INPUT TYPE=SUBMIT NAME=action value="Return to Main Page"></FORM>
   </CENTER></BODY></HTML>
HTML
} 
#===================================================================================
sub doit_modify {
  &load_items;
  print $q->start_html(-TITLE=>'PMA Bulletin Board - Remove Items',-BGCOLOR=>"$backcolor"),
        $q->start_form;
if ($remoteguy eq $sigs[$changeme])
  {

  $items[$changeme] = "$linetomodify\n";
  $sigs[$changeme]  = "$remoteguy\n";
  &save_items;
print<<HTML;
   <CENTER><FONT SIZE=+1 COLOR="$fontcolor">Item Modified</FONT><BR>
   <FORM ACTION="bulletin.cgi" METHOD=POST>
   <HR WIDTH=75%><BR>
   <INPUT TYPE=HIDDEN NAME=key value="$key">
   <INPUT TYPE=SUBMIT NAME=action value="Return to Main Page"></FORM>
   </CENTER></BODY></HTML>
HTML
}
  else {
print<<HTML;
   <CENTER><FONT SIZE=+1 COLOR="$fontcolor">Item Not Modified - Different User Detected</FONT><BR>
   <FORM ACTION="bulletin.cgi" METHOD=POST>
   <HR WIDTH=75%><BR>
   <INPUT TYPE=HIDDEN NAME=key value="$key">
   <INPUT TYPE=SUBMIT NAME=action value="Return to Main Page"></FORM>
   </CENTER></BODY></HTML>
HTML
}


}
#=============================================================================
sub modify_step {
  &load_items;
  print $q->start_html(-TITLE=>'PMA Bulletin Board - Modify an Item',-BGCOLOR=>"$backcolor"),
        $q->start_form;
  $tmp = $items[$changeme];
print<<HTML;
   <CENTER><FONT SIZE=+1 COLOR="$fontcolor">Modify the Item:</FONT><BR><BR>
   <FORM ACTION="bulletin.cgi" METHOD=POST>
   <INPUT TYPE=HIDDEN NAME=changeme value="$changeme" size="60">
   <INPUT TYPE=HIDDEN NAME=key value="$key">
HTML
print "<INPUT TYPE=TEXT NAME=linetomodify VALUE=\"$tmp\" SIZE=\"70\">";
print "<CENTER><BR><INPUT TYPE=SUBMIT NAME=action value=\"Submit\"></FORM>";
print "</CENTER></BODY></HTML>";
}
#=============================================================================
sub print_default {
  &load_items;
  print $q->start_html(-TITLE=>'PMA Bulletin Board',-BGCOLOR=>"$backcolor"),
        $q->start_form;
#<FORM METHOD=post ACTION="bulletin.cgi">
print <<HTML;
  <FONT COLOR=$fontcolor>
  <CENTER>
   <img src="../jpegs/membonly3.jpg" width="414" height="99">
     <table width="50%" bgcolor="#777777">
        <tr><td><CENTER><b><font color="#FFFFFF" size="+1">
        BULLETIN BOARD</font></b></center>
        </td></tr></table>

  <table border=0 width=100% align=center>
    <tr><td width="100%">
	<hr width="100%">
    </td><td width="0">
	<font size=-1>
	<INPUT TYPE=submit NAME=action VALUE="  Add  ">
	</font>
    </td></tr>
  </table>
HTML

  if (@items == 0)
       { print "<CENTER><BR>Currently, there are no messages.</CENTER>"; }
  else { print "<table width=100%>";
         for( $i = 0; $i < 15; ++$i)   # could also be $i < @items
           { 
            	chop $sigs[$i];
		if($sigs[$i] =~ /\./) { &analyzeuser; }
		print <<HTML;
	<tr valign=\"top\" width="25%"><td align=RIGHT>
	 [<FONT COLOR=#FF0000 SIZE=-1>$sigs[$i]</FONT>]</td>
	<td width="80%">
	<font size=-1 color=#CC5500>
		$items[$i]
	</font>
	</td></tr>
HTML
	     }
 	  print "</table>";
       }
print <<HTML;

  <table border=0 width=100% align=center>
    <tr><td width="100%">
	<hr width="100%">
    </td><td width="0">
	<font size=-1>
	<INPUT TYPE=submit NAME=action VALUE="  Add  ">
	</font>
    </td></tr>
  </table>
      </font></form></body></html>
HTML
#      <INPUT TYPE=submit NAME=action VALUE="Modify">

}
#====================================================================
#      <INPUT TYPE=submit NAME=action VALUE="Delete">
#==================================================================
sub filter{ 
  $temp = $_[0];
  $temp =~ s/\|//;
  return ($temp);
}

sub check_empty {
  $r_val = $_[0];
  if($r_val =~ /^\s*$/){$r_val="&nbsp;"}
  return($r_val);
}

sub analyzeuser {
  if    ($sigs[$i] =~ /204.141.60/)      { $sigs[$i] = "E. Koskinen"; }
  elsif ($sigs[$i] =~ /1cust11.tnt19.nyc3/)  { $sigs[$i] = "K. Rehak"; }
  elsif ($sigs[$i] =~ /128.239.206.136/) { $sigs[$i] = "M. Miller"; }
  elsif ($sigs[$i] =~ /128.239.209.121/) { $sigs[$i] = "J. Maga"; }
  elsif ($sigs[$i] =~ /128.239.47/)      { $sigs[$i] = "A. Lagrimas"; }
  elsif ($sigs[$i] =~ /128.239.205/)     { $sigs[$i] = "A. Lagrimas"; }
  elsif ($sigs[$i] =~ /128.239.210.220/) { $sigs[$i] = "E. Walsh"; }
  elsif ($sigs[$i] =~ /128.239.204.182/) { $sigs[$i] = "M. Prosser";  }
  elsif ($sigs[$i] =~ /128.239.213.173/) { $sigs[$i] = "M. Johnson";  }
  elsif ($sigs[$i] =~ /128.239.212.85/)  { $sigs[$i] = "J. Scott";    }
  elsif ($sigs[$i] =~ /199.74.85.114/)   { $sigs[$i] = "A. Jones";    }
  elsif ($sigs[$i] =~ /128.239/) 	 { $sigs[$i] = "Nu Sigma";    }
  else  			         { $sigs[$i] = "Nu Sigma";    }
}

sub load_items {
  open(BULLETIN, $bulletin) or die "Error opening file1: $!\n";
  @items = <BULLETIN>;
  close (BULLETIN);
  open(SIGS, $sigsfile) or die "Error opening file2: $!\n";
  @sigs = <SIGS>;
  close (SIGS);
}

sub save_items {
  open(SAVES,">>$oldfile") or die "Error opening file3: $!\n";
  print SAVES "$savethisone\n";
  close (SAVES);
  open(BULLETIN, ">$bulletin") or die "Error opening file4: $!\n";
  foreach $item2 (@items) { chop $item2; print BULLETIN "$item2\n"; }
  close (BULLETIN);
  open(SIGS, ">$sigsfile") or die "Error opening file5: $!\n";
  foreach $sigs2 (@sigs) { chop $sigs2; print SIGS "$sigs2\n"; }
  close (SIGS);
} 
